/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#define _TTY_POSIX_ 1

#include "qextserialport.h"

#define PROGRAM_LEN 20
#define CHANNEL_LEN 15
#define NAME_LEN        24

// 4ms zwischen den Zeichen
#define CHAR_DELAY 10000		

#define VERSION_STRING "SWB1.3"

void SwitchboxConfig::buttonRead_clicked()
{
	QextSerialPort *mySerialPort = new QextSerialPort();

	mySerialPort->setName(comboPorts->currentText());

	mySerialPort->setBaudRate(BAUD9600);
	mySerialPort->setDataBits(DATA_8);
	mySerialPort->setFlowControl(FLOW_OFF);
	mySerialPort->setParity(PAR_NONE);
	mySerialPort->setStopBits(STOP_1);

	char buffer[100] = {0};
	int programs[4] = { 0 };
	int i = 0,j=0;

	if(mySerialPort->open())
	{
		mySerialPort->putch('i');
		usleep(150000);

		for(i=0;i<strlen(VERSION_STRING);i++)
		{
			buffer[i] = char(mySerialPort->getch());
		}
		buffer[i] = 0;

		if(!strcmp(buffer, VERSION_STRING))
		{
			serialStatusLabel->setText("receiving config");
			this->repaint();
			mySerialPort->putch('g');
		//		sleep(1);

			usleep(150000);	//wait 50ms
			i=0;
			do{
				buffer[i] = (char) mySerialPort->getch();

				if(! ( (i==0) && buffer[i] == 0) )	//kein 0-Byte am Anfang...
				{	
					if(buffer[i] == 0)		//0-Byte im Strom durch Leerzeichen ersetzen
					{
						buffer[i] = ' ';
					}
					i++;
				}

				usleep(CHAR_DELAY);
			} while(i<NAME_LEN);
			buffer[i] = 0;
			editSwitchbox->setText(QString(buffer));

			for(j=0;j<4;j++)
			{
				i=0;
				do{
					buffer[i] = (char) mySerialPort->getch();

					if(! ( (i==0) && buffer[i] == 0) )	//kein 0-Byte am Anfang...
					{	
						if(buffer[i] == 0)		//0-Byte im Strom durch Leerzeichen ersetzen
						{
							buffer[i] = ' ';
						}
						i++;
					}

					usleep(CHAR_DELAY);
				} while(i<PROGRAM_LEN);

				buffer[i] = 0;
				myPrograms[j]->setText(QString(buffer));
			}


			for(j=0;j<4;j++)
			{
				programs[j] = (char) mySerialPort->getch();
				usleep(CHAR_DELAY);
			}

			for(i=0;i<4;i++)
			{
				for(j=0;j<8;j++)
				{
					if((programs[i] & (1<<j)) == 0)
					{
						myCheckboxes[i*8+j]->setChecked(FALSE);
					}
					else
					{
						myCheckboxes[i*8+j]->setChecked(TRUE);
					}
				}
			}

			for(j=0;j<8;j++)
			{
				i=0;
				do{
					buffer[i] = (char) mySerialPort->getch();

					if(! ( (i==0) && buffer[i] == 0) )	//kein 0-Byte am Anfang...
					{	
						if(buffer[i] == 0)		//0-Byte im Strom durch Leerzeichen ersetzen
						{
							buffer[i] = ' ';
						}
						i++;
					}

					usleep(CHAR_DELAY);
				} while(i<CHANNEL_LEN);

				buffer[i] = 0;
				myChannels[j]->setText(QString(buffer));
			}

			serialStatusLabel->setText("config received");

		}
		else
		{
			serialStatusLabel->setText("no switchbox found");
		}		

	}
	else
	{
		serialStatusLabel->setText("error opening rs232");
	}
}

void SwitchboxConfig::buttonWrite_clicked()
{ 
	int i=0, j=0;
	int programs[4] = { 0 };

	QextSerialPort *mySerialPort = new QextSerialPort();

	mySerialPort->setName(comboPorts->currentText());

	mySerialPort->setBaudRate(BAUD9600);
	mySerialPort->setDataBits(DATA_8);
	mySerialPort->setFlowControl(FLOW_OFF);
	mySerialPort->setParity(PAR_NONE);
	mySerialPort->setStopBits(STOP_1);

	char buffer[400] = {};

	qDebug("Name: " + editSwitchbox->text());

	for(i=0;i<32;i++)
	{
		programs[i/8] |= ((myCheckboxes[i]->isChecked() ? (1) : (0)) << (i%8));
	}

	qDebug("\nPrograms:");	
	for(i=0;i<4;i++)
	{
		qDebug(myPrograms[i]->text() + "%2X", programs[i]);
	}

	qDebug("\nChannels:");
	for(i=0;i<8;i++)
	{
		qDebug(myChannels[i]->text());
	}

	//	QString buffer;

	if(mySerialPort->open())
	{
		mySerialPort->putch('i');
		usleep(150000);

		for(i=0;i<strlen(VERSION_STRING);i++)
		{
			buffer[i] = char(mySerialPort->getch());
		}
		buffer[i] = 0;

		if(!strcmp(buffer, VERSION_STRING))
		{

			serialStatusLabel->setText("setting config");
			this->repaint();
			mySerialPort->putch('s');
			usleep(150000);
			//printf("test: %-24s", editSwitchbox->text().ascii());
			sprintf(buffer, "%-24s%-20s%-20s%-20s%-20s",
				editSwitchbox->text().ascii(),
				myPrograms[0]->text().ascii(),
				myPrograms[1]->text().ascii(),
				myPrograms[2]->text().ascii(),
				myPrograms[3]->text().ascii());

			for(i=0;i<strlen(buffer);i++)
			{
				mySerialPort->putch(buffer[i]);
				usleep(CHAR_DELAY);
			}
			for(i=0;i<4;i++)
			{
				mySerialPort->putch(programs[i]);
				usleep(CHAR_DELAY);
			}
/*			
			%c%c%c%c
				programs[0],
				programs[1],
				programs[2],
				programs[3],
*/
			sprintf(buffer, "%-15s%-15s%-15s%-15s%-15s%-15s%-15s%-15s",
				myChannels[0]->text().ascii(),
				myChannels[1]->text().ascii(),
				myChannels[2]->text().ascii(),
				myChannels[3]->text().ascii(),
				myChannels[4]->text().ascii(),
				myChannels[5]->text().ascii(),
				myChannels[6]->text().ascii(),
				myChannels[7]->text().ascii());

			for(i=0;i<strlen(buffer);i++)
			{
				mySerialPort->putch(buffer[i]);
				usleep(CHAR_DELAY);
			}
/*
		for(i=0;i<NAME_LEN;i++)
		{
			//buffer[i] = (editSwitchbox->text());


		}
*/
			serialStatusLabel->setText("config set");
		}
		else
		{
			serialStatusLabel->setText("no switchbox found");
		}
	}	
	else
	{
		serialStatusLabel->setText("error opening rs232");
	}


}



void SwitchboxConfig::buttonProbeRS232_clicked()
{
	qDebug("rs232");

	QextSerialPort *mySerialPort = new QextSerialPort();

	mySerialPort->setName(comboPorts->currentText());

	mySerialPort->setBaudRate(BAUD9600);
	mySerialPort->setDataBits(DATA_8);
	mySerialPort->setFlowControl(FLOW_OFF);
	mySerialPort->setParity(PAR_NONE);
	mySerialPort->setStopBits(STOP_1);

	if(mySerialPort->open())
	{
		mySerialPort->putch('i');
		usleep(150000);
		char buffer[10] = {0};
		int i=0;
		for(i=0;i<strlen(VERSION_STRING);i++)
		{
			buffer[i] = char(mySerialPort->getch());
		}
		buffer[i] = 0;

		if(!strcmp(buffer, VERSION_STRING))
		{
			serialStatusLabel->setText("Switchbox found");
		}
		else
		{
			serialStatusLabel->setText("no switchbox found");
		}
		mySerialPort->close();
	}
	else
	{
		serialStatusLabel->setText("failed!");
	}

	//	mySerialPort->writeBlock("g",1);
		//	mySerialPort->writeBlock

}


void SwitchboxConfig::init()
{
	qDebug("creating checkbox array");

	myCheckboxes[0] = program_1_channel_1;
	myCheckboxes[1] = program_1_channel_2;
	myCheckboxes[2] = program_1_channel_3;
	myCheckboxes[3] = program_1_channel_4;
	myCheckboxes[4] = program_1_channel_5;
	myCheckboxes[5] = program_1_channel_6;
	myCheckboxes[6] = program_1_channel_7;
	myCheckboxes[7] = program_1_channel_8;

	myCheckboxes[8] = program_2_channel_1;
	myCheckboxes[9] = program_2_channel_2;
	myCheckboxes[10] = program_2_channel_3;
	myCheckboxes[11] = program_2_channel_4;
	myCheckboxes[12] = program_2_channel_5;
	myCheckboxes[13] = program_2_channel_6;
	myCheckboxes[14] = program_2_channel_7;
	myCheckboxes[15] = program_2_channel_8;

	myCheckboxes[16] = program_3_channel_1;
	myCheckboxes[17] = program_3_channel_2;
	myCheckboxes[18] = program_3_channel_3;
	myCheckboxes[19] = program_3_channel_4;
	myCheckboxes[20] = program_3_channel_5;
	myCheckboxes[21] = program_3_channel_6;
	myCheckboxes[22] = program_3_channel_7;
	myCheckboxes[23] = program_3_channel_8;

	myCheckboxes[24] = program_4_channel_1;
	myCheckboxes[25] = program_4_channel_2;
	myCheckboxes[26] = program_4_channel_3;
	myCheckboxes[27] = program_4_channel_4;
	myCheckboxes[28] = program_4_channel_5;
	myCheckboxes[29] = program_4_channel_6;
	myCheckboxes[30] = program_4_channel_7;
	myCheckboxes[31] = program_4_channel_8;

	qDebug("creating channel array");

	myChannels[0] = editChannel_1;
	myChannels[1] = editChannel_2;
	myChannels[2] = editChannel_3;
	myChannels[3] = editChannel_4;
	myChannels[4] = editChannel_5;
	myChannels[5] = editChannel_6;
	myChannels[6] = editChannel_7;
	myChannels[7] = editChannel_8;

	qDebug("creating program array");

	myPrograms[0] = editProgram_1;
	myPrograms[1] = editProgram_2;
	myPrograms[2] = editProgram_3;
	myPrograms[3] = editProgram_4;

//	program_1_channel_1
}
